function [q,c]=quant(s,r)
%QUANT	[q c] = quant(s,r)
%
%	QUANTIZADOR
%
%	s: sinal nao quantizado
%	q: sinal quantizado
%	c: codigo (indices dos niveis quantizados)
%	r: tabela de niveis de representacao
%	   (no. de niveis tem que ser potencia de 2)

%
% Criado por Miguel Arjona Ramrez em 4 de agosto de 1992.
%
s=s(:);
N=prod(size(s));
r=r(:);
M=prod(size(r));		% no. de niveis
nu=log(M)/log(2);		% no. de bits
x=(r(2:M)+r(1:M-1))/2;		% niveis de decisao correspondentes
%
p2=(2*ones(1,nu)).^(nu-1:-1:0);	% potencias de 2
%
sar=zeros(N,1);			% inicializa registradores de aprox. sucessiva
for b=1:nu
    sarn=sar+p2(b);		% indices de comparacao (indexam decisao)
%				  (niveis de atualizacao do sar)
    xc=x(sarn);
    xc=xc(:);
    comp=find(s>xc);		% conversoes a atualizar
    sar(comp)=sarn(comp);
end;
%
c=sar+1;			% passa a indexar niveis de representacao
q=r(c);
